# -*- coding: utf-8 -*-
# %% Poglavje 1

import numpy as np
from matplotlib import pyplot as pp
from PIL import Image as im
import funkcije

#%% Naloga 1
pilSlika = im.open('./poglavje_1/mrBrainSlice.png')
npSlika = np.array(pilSlika)

pp.figure()
pp.imshow(npSlika, cmap='gray')
pp.show()

#%% Naloga 2
npSlika.tofile(
  './poglavje_1/rezultati/mrBrainSlice_217x181_uint8.raw')

#%% Naloga 3
# prtetvorimo v 16-bitni nepredznačeni zapis
npSlika16 = np.round(
  npSlika.astype(np.float64)*(65535.0/255.0)).astype(np.uint16)
# shranimo v surovo binarno datoteko
npSlika16.tofile(
  './poglavje_1/rezultati/mrBrainSlice_217x181_uint16.raw')
# shranimo v 16-bitno tif datoteko
pilSlika32 = im.fromarray(npSlika16.astype(np.int32))
pilSlika32.save('./poglavje_1/rezultati/mrBrainSlice.tif')

#%% Naloga 4
npRaw8 = np.fromfile(
  './poglavje_1/rezultati/mrBrainSlice_217x181_uint8.raw',
  dtype=np.uint8, count=217*181)
npRaw8.shape = (181, 217)

npRaw16 = np.fromfile(
  './poglavje_1/rezultati/mrBrainSlice_217x181_uint16.raw',
  dtype=np.uint16, count=217*181)
npRaw16.shape = (181, 217)

pp.figure()

pp.subplot(1, 2, 1)
pp.imshow(npRaw8, cmap='gray')
pp.title('Slika mrBrainSlice_217x181_uint8.raw')

pp.subplot(1, 2, 2)
pp.imshow(npRaw16, cmap='gray')
pp.title('Slika mrBrainSlice_217x181_uint16.raw')

pp.show()

#%% Naloga 5 
# Naloga a) Glej funkcijo imLoadRaw2d v modulu funkcije.
# Naloga b) Glej funkcijo imSaveRaw2d v modulu funkcije.

mr8 = funkcije.imLoadRaw2d(
  './poglavje_1/rezultati/mrBrainSlice_217x181_uint8.raw',
  217, 181)
mr16 = funkcije.imLoadRaw2d(
  './poglavje_1/rezultati/mrBrainSlice_217x181_uint16.raw',
  217, 181, np.uint16)

pp.figure()

pp.subplot(1, 2, 1)
pp.imshow(mr8, cmap='gray')
pp.title('Slika mrBrainSlice_217x181_uint8.raw')

pp.subplot(1, 2, 2)
pp.imshow(mr16, cmap='gray')
pp.title('Slika mrBrainSlice_217x181_uint16.raw')

pp.show()

#%% Naloga 6
pp.figure()
pp.imshow(mr8[60:120+1, 80:160+1], cmap='gray')
pp.title('Podokno [60:121, 80:161]')
pp.show()

## Naloga 7
maska = np.logical_and(mr8 >= 160, mr8 <= 200)
mrRgb = np.zeros([181, 217, 3], dtype=np.uint8)
mrRgb[maska, 0] = 255

pp.figure()

pp.subplot(1, 3, 1)
pp.imshow(mr8, cmap='gray')
pp.title('Izvirna')

pp.subplot(1,3,2)
pp.imshow(maska, cmap='gray')
pp.title('Binarna sivinska')

pp.subplot(1, 3, 3)
pp.imshow(mrRgb)
pp.title('Binarna barvna')

#%% Naloga 8 
# Naloga a) Glej funkcijo imLoadRaw3d v modulu funkcije.
# Naloga b) Glej funkcijo imSaveRaw3d v modulu funkcije.

mr3d = funkcije.imLoadRaw3d(
  './poglavje_1/mr_217x181x181_uint8.raw', 217, 181, 181)

pp.figure()

pp.subplot(1, 3, 1)
pp.imshow(mr3d[:, :, 100], cmap='gray')
pp.title('Prerez slike pri [:, :, 100]')

pp.subplot(1, 3, 2)
pp.imshow(mr3d[:, 100, :], cmap='gray')
pp.title('Prerez slike pri [:, 100, :]')

pp.subplot(1, 3, 3)
pp.imshow(mr3d[100, :, :], cmap='gray')
pp.title('Prerez [100, :, :]')

pp.show()

#%% Naloga 9
# koordinatno izhodišče v geometričnem središču slike
Y2d_c, X2d_c = funkcije.imGrid2d(16, 9, 2.0, 2.0, 'center', 'center')
# koordinatno izhodišče v krajišču slike
Y2d, X2d = funkcije.imGrid2d(16, 9, 2.0, 2.0)

pp.figure()
pp.plot(X2d_c, Y2d_c, '.k')
pp.plot(X2d, Y2d, '.r')
pp.title('16 x 9 sl. el. vel. 2 x 2 mm')
pp.xlabel('x (mm)')
pp.ylabel('y (mm)')
pp.show()
