# -*- coding: utf-8 -*-
#%% Poglavje 10

import funkcije
import numpy as np
from matplotlib import pyplot as pp
from PIL import Image as im
import time

# naložimo slike in usvarimo spremenljivke
It = np.array(im.open('./poglavje_10/proj2d_test.png'))
Ht, Wt = It.shape
xt = np.arange(-(Wt - 1)*0.5, (Wt - 1)*0.5 + 0.5, 1)
yt = np.arange(-(Ht - 1)*0.5, (Ht - 1)*0.5 + 0.5, 1)

Ict = np.array(im.open('./poglavje_10/proj2d_ct.png'))
Hct, Wct = Ict.shape
dy, dx = 2, 2
xct = np.arange(-dx*(Wct - 1)*0.5, dx*(Wct - 1)*0.5 + 0.5*dx, dx)
yct = np.arange(-dy*(Hct - 1)*0.5, dy*(Hct - 1)*0.5 + 0.5*dy, dy)

fi = np.deg2rad(np.arange(360))

#%% Naloga 1
# V modulu funkcije ustvarimo funkcijo imParallelBeamProject2d.

# Naloga a)
start = time.perf_counter()
ItPS = funkcije.imParallelBeamProject2d(
  fi, 2, It, xt, yt, 800, 512, 1, 'sum')
print('Izračun {} pravokotnih projekcij testne slike '
      'v {} s'.format(fi.size, time.perf_counter() - start))

pp.figure()
pp.suptitle('Testna slika s pripadajočim sinogramom - '
            'pravokotna projekcija.')

pp.subplot(1, 2, 1)
pp.imshow(It, cmap='gray')

pp.subplot(1, 2, 2)
pp.imshow(ItPS, cmap='gray')

pp.show()
# Naloga b)
start = time.perf_counter()
IctPS = funkcije.imParallelBeamProject2d(
  fi, 2, Ict, xct, yct, 800, 512, 1, 'sum')
print('Izračun {} pravokotnih projekcij CT rezine '
      'v {} s'.format(fi.size, time.perf_counter() - start))

pp.figure()
pp.suptitle('Rezina CT slike s pripadajočim sinogramom - '
            'pravokotna projekcija.')

pp.subplot(1, 2, 1)
pp.imshow(Ict, cmap='gray')
pp.subplot(1, 2, 2)
pp.imshow(IctPS, cmap='gray')

pp.show()
#%% Naloga 2
# V modulu funkcije ustvarimo funkcijo imFanBeamProject2d.

# Naloga a)
start = time.perf_counter()
ItSS = funkcije.imFanBeamProject2d(
  fi, 2, It, xt, yt, 800, 512, 1, 'sum')
print('Izračun {} stožčastih projekcij testne slike v {} s'.format(
      fi.size, time.perf_counter() - start))

pp.figure()
pp.suptitle('Testna slika s pripadajočim sinogramom - '
            'stožčasta projekcija.')

pp.subplot(1, 2, 1)
pp.imshow(It, cmap='gray')

pp.subplot(1, 2, 2)
pp.imshow(ItSS, cmap='gray')

pp.show()

# Naloga b)
step = [1.0, 2.0, 4.0, 8.0]
TSS = []
ISSt = []

pp.figure()
pp.suptitle('Sinogram testne slike v odvisnosti od koraka vzorčenja.')
for stepi in step:
  start = time.perf_counter()
  s = funkcije.imFanBeamProject2d(
    fi, stepi, It, xt, yt, 800, 512, 1, 'sum')
  TSS.append(time.perf_counter() - start)     
  ISSt.append(s)
  pp.subplot(1, 4, len(TSS))
  pp.imshow(s, cmap='gray')
  pp.title('Korak vzorčenja {:.1f} mm v {:.1f} s'.format(
           stepi, TSS[-1]))

pp.show()
# Naloga c)
start = time.perf_counter()
IctSS = funkcije.imFanBeamProject2d(
  fi, 2, Ict, xct, yct, 800, 512, 1, 'sum')
print('Izračun {} stožčastih projekcij CT rezine v {} s'.format(
      fi.size, time.perf_counter() - start))

pp.figure()
pp.suptitle('Rezina CT slike s pripadajočim sinogramom - '
            'stožčasta projekcija.')

pp.subplot(1, 2, 1)
pp.imshow(Ict, cmap='gray')

pp.subplot(1, 2, 2)
pp.imshow(IctSS, cmap='gray')

pp.show()
