# -*- coding: utf-8 -*-
#%% Poglavje 5

import funkcije
import numpy as np
from matplotlib import pyplot as pp
from PIL import Image as im
import interp


I = funkcije.imLoadRaw3d(
  './poglavje_5/ct_287x165x194_uint8.raw', 287, 165, 194)

D, H, W = I.shape

dx, dy, dz = 2.0, 2.0, 4.0
Hmm, Wmm, Dmm = H*dy, W*dx, D*dz
IxExtent = [0, Hmm, 0, Dmm]
x, y, z = np.arange(W)*dx, np.arange(H)*dy, np.arange(D)*dz
zi = np.arange(0, Dmm, 2.0)
yi = np.tile(175.0, zi.shape)
nBins = 64

#%% Naloga 1

# Naloga a)
# V modulu funkcije ustvarimo funkcijo imShowEx.

# Naloga b)
pp.figure()
Iprecni = I[int(200/dz), :, :].squeeze()
funkcije.imShowEx(Iprecni, extent=[0, Wmm, 0, Hmm],
                  title='Prečni prerez z=200 mm', subplot=131)
Icelni = I[:, int(220/dy), :].squeeze()
funkcije.imShowEx(Icelni, extent=[0, Wmm, 0, Dmm],
                  title='Čelni prerez y=220 mm', subplot=132)
Ix = Istranski = I[:, :, int(280/dx)].squeeze()
funkcije.imShowEx(Istranski, extent=[0, Hmm, 0, Dmm],
                  title='Stranski prerez x=280 mm', subplot=133)

# Naloga c)
pp.figure()
IprecniMax = I.max(0)
funkcije.imShowEx(IprecniMax, extent=[0, Wmm, 0, Hmm],
                  title='Maks. projekcija vzdolž z', subplot=131)
IcelniMax = I.max(1)
funkcije.imShowEx(IcelniMax, extent=[0, Wmm, 0, Dmm],
                  title='Maks. projekcija vzdolž y', subplot=132)
IstranskiMax = I.max(2)
funkcije.imShowEx(IstranskiMax, extent=[0, Hmm, 0, Dmm],
                  title='Maks. projekcija vzdolž x', subplot=133)

pp.show()

#%% Naloga 2

# Naloga a)
# V modulu funkcije ustvarimo funkcijo imScale.

# Naloga b)
IxScaled = funkcije.imScale(Ix, -1.0, 255.0)
pp.figure()

# Ix
funkcije.imShowEx(Ix, extent=IxExtent,
                  subplot=231, title='Izvirna slika')
pp.plot(yi,zi,'-b')
pp.subplot(2, 3, 2)
pp.hist(Ix.flatten(), nBins, [0, 256], normed=True)
pp.xlim([0, 256])
pp.subplot(2, 3, 3)
pp.plot(zi, interp.interp2(yi, zi, y, z, Ix))
pp.ylim([0, 255])
# IxScaled
funkcije.imShowEx(IxScaled, extent=IxExtent,
                  subplot=234, title='imScale')
pp.plot(yi,zi,'-b')
pp.subplot(2, 3, 5)
pp.hist(IxScaled.flatten(), nBins, [0, 256], normed=True)
pp.xlim([0, 256])
pp.subplot(2, 3, 6)
pp.plot(zi, interp.interp2(yi, zi, y, z, IxScaled))
pp.ylim([0, 255])

pp.show()

#%% Naloga 3

# Naloga a)
# V modulu funkcije ustvarimo funkcijo imWindow.

# Naloga b)
tmp = np.sort(Ix.flatten())
start = tmp[round(tmp.size*0.05)] + 1
end = tmp[round(tmp.size*0.95)] - 1
center = 0.5*(start + end)
width = end - start
IxWindow = funkcije.imWindow(Ix, center, width)

pp.figure()

# Ix
funkcije.imShowEx(Ix, extent=IxExtent,
                  subplot=231, title='Izvirna slika')
pp.plot(yi,zi,'-b')
pp.subplot(2, 3, 2)
pp.hist(Ix.flatten(), nBins, [0, 256], normed=True)
pp.xlim([0, 256])
pp.subplot(2, 3, 3)
pp.plot(zi, interp.interp2(yi, zi, y, z, Ix))
pp.ylim([0, 255])

# IxWindow
funkcije.imShowEx(IxWindow, extent=IxExtent,
                  subplot=234, title='imWindow')
pp.plot(yi,zi,'-b')
pp.subplot(2, 3, 5)
pp.hist(IxWindow.flatten(), nBins, [0, 256], normed=True)
pp.xlim([0, 256])
pp.subplot(2, 3, 6)
pp.plot(zi, interp.interp2(yi, zi, y, z, IxWindow))
pp.ylim([0, 255])

pp.show()

#%% Naloga 4

# Naloga a)
# V modulu funkcije ustvarimo funkcijo imThreshold.

# Naloga b)
IxThreshold = funkcije.imThreshold(Ix, 127)
pp.figure()
# Ix
funkcije.imShowEx(Ix, extent=IxExtent,
                  subplot=121, title='Izvirna slika')

# IxThreshold
funkcije.imShowEx(IxThreshold, extent=IxExtent,
                  subplot=122, title='IxThreshold')

pp.show()

#%% Naloga 5

# Naloga a)
# V modulu funkcije ustvarimo funkcijo imGamma.

# Nalog b)
IxGamma = funkcije.imGamma(Ix, 2)

pp.figure()
# Ix
funkcije.imShowEx(Ix, extent=IxExtent,
                  subplot=231, title='Izvirna slika')
pp.plot(yi,zi,'-b')
pp.subplot(2, 3, 2)
pp.hist(Ix.flatten(), nBins, [0, 256], normed=True)
pp.xlim([0, 256])
pp.subplot(2, 3, 3)
pp.plot(zi, interp.interp2(yi, zi, y, z, Ix))
pp.ylim([0, 255])

# IxWindow
funkcije.imShowEx(IxGamma, extent=IxExtent,
                  subplot=234, title='IxGamma')
pp.plot(yi,zi,'-b')
pp.subplot(2, 3, 5)
pp.hist(IxGamma.flatten(), nBins, [0, 256], normed=True)
pp.xlim([0, 256])
pp.subplot(2, 3, 6)
pp.plot(zi, interp.interp2(yi, zi, y, z, IxGamma))
pp.ylim([0, 255])

pp.show()

#%% Naloga 6

# Naloga a)
# V modulu funkcije ustvarimo funkcijo imMultiscale.

# Naloga b)
gamma = 2
gammaApproxN = [2, 4, 8, 16]
N = len(gammaApproxN)
gammaApproxImg = []
gammaRef = funkcije.imGamma(Ix, gamma)
rGamma = np.linspace(0, 255, 1000)
sGamma = funkcije.imGamma(rGamma, gamma)

pp.figure()
pp.suptitle('Aproksimacija gama preslikave (gamma={}) '\
            'z odsekoma linearno preslikavo'.format(gamma))

for index, n in enumerate(gammaApproxN):
  r = np.linspace(0.0, 255.0, n)
  s = funkcije.imGamma(r, gamma)
  approx = funkcije.imMultiscale(Ix, r, s)
  gammaApproxImg.append(approx)

  funkcije.imShowEx(approx, extent=IxExtent,
                    subplot=(3, N, index + 1),
                    title='Št. segmentov n={}'.format(n),
                    vmin=0, vmax=255)

  pp.subplot(3, N, N + index + 1)
  pp.title('Napaka')
  pp.imshow(gammaRef - approx, cmap='gray')
  pp.colorbar()

  pp.subplot(3, N, 2*N + index + 1)
  pp.plot(r, s, '.-r', label='Odsek. lin.')
  pp.plot(rGamma, sGamma, '--b', label='Gama')
  pp.legend()

pp.show()

#%% Naloga 7

# Naloga a)
p2a, p2ax, p2ay = funkcije.imProfile2d(
  Ix,
  [0.0, 0.0], [y[-1], z[-1]], y, z, step=2.0, order=1)
p2b, p2bx, p2by = funkcije.imProfile2d(
  Ix,
  [y[-1], 0.0], [0.0, z[-1]], y, z, step=2.0, order=1)

pp.figure()
funkcije.imShowEx(Ix, subplot=121, extent=IxExtent)
pp.plot([0.0, y[-1]], [0.0, z[-1]], '-r')
pp.plot([y[-1], 0.0], [0.0, z[-1]], '-g')
pp.subplot(1, 2, 2)
pp.plot(p2a, '-r')
pp.plot(p2b, '-g')
pp.ylim([0, 255])

pp.show()

# Naloga b)
p3, p3x, p3y, p3z = funkcije.imProfile3d(I, 
  [0.0, 0.0, 0.0], [x[-1], y[-1], z[-1]], x, y, z, step=2.0, order=1)

pp.figure()
pp.plot(p3)
pp.ylim([0, 255])

pp.show()
