# -*- coding: utf-8 -*-
#%% Poglavje 6

import funkcije
import numpy as np
from matplotlib import pyplot as pp
from PIL import Image as im

I = np.asarray(im.open('./poglavje_6/shading_muscle.png'))
HI, WI = I.shape
Id = np.asarray(im.open('./poglavje_6/shading_dark.png'))
Ib = np.asarray(im.open('./poglavje_6/shading_bright.png'))
nBins = 64

Il = np.asarray(im.open('./poglavje_6/shading_lung.png'))
HIl, WIl = Il.shape

Is1 = np.asarray(im.open('./poglavje_6/shading_1.png'))
Is2 = np.asarray(im.open('./poglavje_6/shading_2.png'))
Is3 = np.asarray(im.open('./poglavje_6/shading_3.png'))
Is4 = np.asarray(im.open('./poglavje_6/shading_4.png'))
HIs, WIs = Is1.shape

#%% Naloga 1

# Naloga a)
# V modulu funkcije ustvarimo funkcijo imShadingCalibrate.

# Naloga b)
pp.figure()

funkcije.imShowEx(I, title='Nehomogena', subplot=131,
  vmin=0, vmax=255)
pp.plot([0, WI - 1],[HI//2,HI//2], '-b')

pp.subplot(1, 3, 2)
pp.hist(I.flatten(), nBins, [0, 256], normed=True)

pp.subplot(1, 3, 3)
pp.plot(I[HI//2])
pp.ylim([0, 255])

# Naloga c)
Ic, IcA, IcM = funkcije.imShadingCalibrate(I, Id, Ib, 0, 192)

pp.figure()

funkcije.imShowEx(Ic, title='Obnovljena', subplot=141,
                vmin=0, vmax=255)
pp.plot([0, WI - 1],[HI//2,HI//2], '-b')
funkcije.imShowEx(IcM, title='Multiplikativno polje', subplot=142)

pp.subplot(1, 4, 3)
pp.hist(Ic.flatten(), nBins, [0, 256], normed=True)

pp.subplot(1, 4, 4)
pp.plot(Ic[HI//2])
pp.ylim([0, 255])

pp.show()

# Prostorska nehomogenost sivinskih vrednosti se odraža v
# nizkofrekvenčni komponenti linijskega prereza. V histogram vnaša
# razširitev porazdelitve sivinskih vrednosti, ki pripadajo določenemu tkivu.

#%% Naloga 2

# Naloga a)
# V modulu funkcije prilagodimo funkcijo imShadingCalibrate.

# Naloga b)
Ic1, tmp, Ic1M = funkcije.imShadingCalibrate(I, bright=Ib, b=192)

pp.figure()

funkcije.imShowEx(Ic1, title='Obnovljena', subplot=141,
                  vmin=0, vmax=255)
pp.plot([0, WI - 1],[HI//2,HI//2], '-b')
funkcije.imShowEx(Ic1M, title='Multiplikativno polje', subplot=142)
pp.subplot(1, 4, 3)
pp.hist(Ic1.flatten(), nBins, [0, 256], normed=True)
pp.subplot(1, 4, 4)
pp.plot(Ic1[HI//2])
pp.ylim([0, 255])

pp.show()

# Naloga c)
# Kalibracija slike z aditivnim modelom ni ustrezna, saj je svetlost temne
# kalibracijske slike zanemarljiva, svetlostna nehomogenost v svetli
# kalibracijski sliki pa izrazita.

#%% Naloga 3

# Naloga a)
# V modulu funkcije ustvarimo funkcijo imShadingFilter.

# Naloga b)
Ifc, IfA = funkcije.imShadingFilter(I, sigma=50)
Ifc = (Ifc - Ifc.mean())/Ifc.std()*I.std() + I.mean()

pp.figure()

funkcije.imShowEx(Ifc, title='Obnovljena', subplot=141,
                  vmin=0, vmax=255)
funkcije.imShowEx(IfA, title='Aditivno polje', subplot=142)
pp.plot([0, WI - 1],[HI//2,HI//2], '-b')

pp.subplot(1, 4, 3)
pp.hist(Ifc.flatten(), nBins, [0, 256], normed=True)

pp.subplot(1, 4, 4)
pp.plot(Ifc[HI//2])

# Naloga c)
Ilfc, IlfA = funkcije.imShadingFilter(Il, sigma=20)
Ilfc = (Ilfc - Ilfc.mean())/Ilfc.std()*Il.std() + Il.mean()

pp.figure()

funkcije.imShowEx(Ilfc, title='Obnovljena', subplot=141,
                  vmin=0, vmax=255)
funkcije.imShowEx(IlfA, title='Aditivno polje', subplot=142)
pp.plot([0, WI - 1],[HI//2,HI//2], '-b')

pp.subplot(1, 4, 3)
pp.hist(Ilfc.flatten(), nBins, [0, 256], normed=True)

pp.subplot(1, 4, 4)
pp.plot(Ilfc[HIl//2])

std = [7, 14, 28, 56]
Is = [Is1, Is2, Is3, Is4]
Ifsc = []
IfscM = []
for i in range(4):
  s = Is[i]
  sc, sca = funkcije.imShadingFilter(s, sigma=std[i])
  sc = (sc - sc.mean())/sc.std()*s.std() + s.mean()
  Ifsc.append(sc)
  IfscM.append(sca)

  pp.figure()

  funkcije.imShowEx(s, title='Izvirna', subplot=241,
                    vmin=0, vmax=255)
  pp.plot([0, WIs - 1],[HIs//2, HIs//2], '-b')

  pp.subplot(2, 4, 3)
  pp.hist(s.flatten(), nBins, [0, 256], normed=True)

  pp.subplot(2, 4, 4)
  pp.plot(s[int(HIs//2)])
  
  funkcije.imShowEx(sc, title='Obnovljena', subplot=245,
                    vmin=0, vmax=255)
  pp.plot([0, WIs - 1],[HIs//2, HIs//2], '-b')
  funkcije.imShowEx(sca, title='Aditivno polje', subplot=246)
  
  pp.subplot(2, 4, 7)
  pp.hist(sc.flatten(), nBins, [0, 256], normed=True)
  
  pp.subplot(2, 4, 8)
  pp.plot(sc[int(HIs//2)])

pp.show()

# Z večanjem velikosti pravokotnih področij testnih slik narašča tudi
# napaka pri oceni polja nehomogenosti s postopkom filtriranja.

#%% Naloga 4

# Naloga a)
# V modulu funkcije ustvarimo funkcijo imShadingHomomorphic.

# Naloga b)
Ihfc, IhfM = funkcije.imShadingHomomorphic(I, sigma=50)
Ihfc = (Ihfc - Ihfc.mean())/Ihfc.std()*I.std() + I.mean()

pp.figure()

funkcije.imShowEx(Ihfc, title='Obnovljena', subplot=141,
                  vmin=0, vmax=255)
funkcije.imShowEx(IhfM, title='Multiplikativno polje', subplot=142,
                  vmin=0, vmax=255)
pp.plot([0, WI - 1],[HI//2, HI//2], '-b')

pp.subplot(1, 4, 3)
pp.hist(Ihfc.flatten(), nBins, [0, 256], normed=True)

pp.subplot(1, 4, 4)
pp.plot(Ihfc[int(HI//2)])

pp.show()

# Naloga c)
Ilhfc, IlhfM = funkcije.imShadingHomomorphic(Il, sigma=20)
Ilhfc = (Ilhfc - Ilhfc.mean())/Ilhfc.std()*Il.std() + Il.mean()

pp.figure()

funkcije.imShowEx(Ilhfc, title='Obnovljena', subplot=141,
                  vmin=0, vmax=255)
funkcije.imShowEx(IlhfM, title='Multiplikativno polje', subplot=142,
                  vmin=0, vmax=255)
pp.plot([0, WIl - 1],[HIl//2, HIl//2], '-b')

pp.subplot(1, 4, 3)
pp.hist(Ilhfc.flatten(), nBins, [0, 256], normed=True)

pp.subplot(1, 4, 4)
pp.plot(Ilhfc[int(HIl//2)])


std = [7, 14, 28, 56]
Is = [Is1, Is2, Is3, Is4]
Ihfsc = []
IhfscM = []
for i in range(4):
  s = Is[i]
  sc, scm = funkcije.imShadingHomomorphic(s, sigma=std[i])
  sc = (sc - sc.mean())/sc.std()*s.std() + s.mean()
  Ihfsc.append(sc)
  IhfscM.append(scm)

  pp.figure()
  funkcije.imShowEx(s, title='Izvirna', subplot=241,
    vmin=0, vmax=255)
  pp.plot([0, WIs - 1],[HIs//2, HIs//2], '-b')

  pp.subplot(2, 4, 3)
  pp.hist(s.flatten(), nBins, [0, 256], normed=True)

  pp.subplot(2, 4, 4)
  pp.plot(s[int(HIs//2)])
  
  funkcije.imShowEx(sc, title='Obnovljena', subplot=245)
  pp.plot([0, WIs - 1],[HIs//2, HIs//2], '-b')
  funkcije.imShowEx(scm, title='Multiplikativno polje', subplot=246,
    vmin=0, vmax=255)

  pp.subplot(2, 4, 7)
  pp.hist(sc.flatten(), nBins, [0, 256], normed=True)

  pp.subplot(2, 4, 8)
  pp.plot(sc[int(HIs//2)])

pp.show()

# Z večanjem velikosti pravokotnih področij testnih slik narašča tudi
# napaka pri oceni polja nehomogenosti s postopkom filtriranja.
